// Endogenous Variables
var qU, piU, rkU, RXU, RkXU, kbarU, hU, lambdazU, cU, iU, sU, wU, uU, mbU, mU, yU, omegabarU, nU, vlU, evU, RaXU, ReXU, m2U, btotU,  pstarU, FpXU, wstarU, FwXU, 
xU, gU, gammaU, sigmaU, lambdafU, epsilU, muzstarU, muzU, zetaiU, zetacU, sigmaqU, upsilU, xbU, lambdawU, gp_obs, gc_obs, gi_obs, gy_obs, R_obs, gw_obs, gg_obs, gm2_obs, gn_obs, gh_obs, gm_obs;

// Exogenous Variables
varexo e_policyU, e_gU, e_gammaU, e_sigmaU, e_lambdafU, e_muzU, e_epsilU, e_zetaiU, e_zetacU, e_sigmaqU, e_upsilU, e_xbU, e_lambdawU, e_zetalU;

// calibrated parameters
parameters vUU, betaUU, bUU, alphaUU, psikUU, psilUU, psiLXUU, sigmaLXUU, deltaUU, taukUU, taulUU, taucUU, muUU, weUU, bigthetaUU, ksiUU, tauUU, thetaUU;
// Steady-state values:
parameters lambdafUU, etagUU, muzstarUU, muzUU, zetaiUU, xUU, gUU, gammaUU, sigmaUU, epsilUU, zetacUU, upsilUU, sigmaqUU, xbUU, lambdawUU;
parameters rho1_lambdafU, rho1_epsilU, rho1_gU, rho1_gammaU, rho1_sigmaU, rho1_muzU, rho1_zetaiU, rho1_xbU, rho1_zetacU, rho1_sigmaqU, rho1_upsilU, rho1_lambdawU;
parameters std1_lambdafU, std1_e6psilU, std1_gU, std1_gammaU, std1_sigmaU, std1_muzU, std1_zetaiU, std1_xbU, std1_zetacU, std1_sigmaqU, std1_upsilU, std1_lambdawU;//, std1_xU,
//ss endo vars
parameters qUU, uUU, piUU, RXUU, RkXUU, rkUU, sUU, wUU, kbarUU, cUU, iUU, hUU, lambdazUU, mbUU, mUU, yUU, omegabarUU, nUU, vlUU, evUU, RaXUU, ReXUU, m2UU, btotUU, pstarUU, FpXUU, wstarUU, FwXUU;//arUU, mrUU;
//parameters to be estimated
parameters xipUU, xiwUU, iotamuUU, iota1UU, iotaw1UU, sigmaIXUU, sigmaaUU, policytilUU, policypiUU, policyyUU;

pstarUU=1;
FpXUU=6.8428;
wstarUU=1;
//FwXUU=hUU*lambdazUU*(1-taulUU)/lambdawUU/(1-betaUU*xiwUU*(piUU*muzstarUU)^(1/(1-lambdawUU)));
FwXUU=0.9658;
//arUU=muUU*normcdf((log(omegabarUU)-sigmaUU^2/2)/sigmaUU)*(1+RkXUU)*kbarUU*qUU/( kbarUU*qUU-nUU)
//arUU=0.00015083;
//mrUU=omegabarUU*(1+RkXUU)*kbarUU/(kbarUU-nUU)-1-ReXUU
//mrUU=0.0012;


RXUU = 0.0258;
RaXUU = 0.022240872072947025;
ReXUU = 0.031192823082308196;
RkXUU = 0.032020049999999856;
alphaUU = 0.4;
bUU = 0.63;
betaUU = 0.9999;
bigthetaUU = 0.1;
btotUU = 4.1341182660068041;
cUU = 0.46402492810084189;
deltaUU = 0.025;
epsilUU = 1;
etagUU = 0.18;
evUU = 29.414538151324003;
gUU = 0.18662589160213688;
gammaUU = 0.976;
hUU = 0.38800577082746096;
iUU = 0.38416199549503321;
kbarUU = 7.7195179472332578;
ksiUU = 0.371075483093525;
lambdafUU = 1.2;
lambdawUU = 1.05;
lambdazUU = 1.9594540281944486;
m2UU = 4.9183430907490315;
mUU = 0.23;
mbUU = 0.80860614225607064;
muUU = 0.016290434611943416;
muzUU = 1.026062;
muzstarUU = 1.026062;
nUU = 4.4168424375275022;
omegabarUU = 0.428;
piUU = 1.0049;
psiLXUU = 6.9244047422263453;
psikUU = 0.9;
psilUU = 0.9;
qUU = 1;
rkUU = 0.055;
sUU = 0.83333333333333337;
sigmaLXUU = 1;
sigmaUU = 0.34;
sigmaqUU = 0.57;
tauUU = 0.15;
taucUU = 0.1;
taukUU = 0.1;
taulUU = 0.1;
thetaUU = 0.51;
uUU = 1;
upsilUU = 1;
vUU = 0.035;
vlUU = 0.99;
wUU = 1.599677148675934;
weUU = 0.1;
xUU = 0.031089703799999979;
xbUU = 14.407543928537999;
yUU = 1.047908807249363;
zetacUU = 1;
zetaiUU = 1;
//parameters to be estimated
xipUU=0.7;
xiwUU=0.6;
iotamuUU=0.5;
iota1UU=0.3;
iotaw1UU=0.5;
sigmaIXUU=3;
sigmaaUU=8;
rho1_lambdafU=0.15;
rho1_epsilU=0.15;
rho1_gU=0.7;
rho1_muzU=0.3;
rho1_zetaiU=0.5;
rho1_zetacU=0.3;
rho1_sigmaqU=0.5;
rho1_upsilU=0.2;
rho1_lambdawU=0.5;
rho1_gammaU=0.7;
rho1_sigmaU=0.5;
rho1_xbU=0.5;

policytilUU=0.95;
policypiUU=1.5;
policyyUU=1.2;

//Model
model;

//Conditions associated with Calvo sticky prices
//(eq A.3)
pstarU - ((1-xipUU)*( ( ( (1 - xipUU*(( (piUU^iota1UU) * (piU(-1)^(1-iota1UU))  )/piU)^(1/(1-lambdafU)) ) / (1-xipUU) ) ) ^ lambdafU ) + xipUU*(((( (piUU^iota1UU) * (piU(-1)^(1-iota1UU))  )/piU)*pstarU(-1))^( lambdafU / (1-lambdafU) )) )^(1/( lambdafU / (1-lambdafU) ));
//(eq A.4)
//zetacU*lambdazU*( (pstarU^(lambdafU/(lambdafU-1))) * ( epsilU * vlUU * ( (uU*kbarU(-1)/(muzstarU*upsilUU))^alphaUU ) * ( ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU ) ) + ( (( (pitargetU(+1)^iota1UU) * (piU^(1-iota1UU)) * pibarUU^(1-iota1UU-(1-iota1UU)) )/piU(+1)) ^ (1/(1-lambdafU(+1))) ) * betaUU * xipUU * FpXU(+1) - FpXU;
lambdazU*yU+ ( (( (piUU^iota1UU) * (piU^(1-iota1UU)))/piU(+1)) ^ (1/(1-lambdafU(+1))) ) * betaUU * xipUU * FpXU(+1) - FpXU;
//(eq A.5) 
//zetacU*lambdafU*lambdazU*( (pstarU^(lambdafU/(lambdafU-1))) * ( epsilU * vlUU * ( (uU*kbarU(-1)/(muzstarU*upsilUU))^alphaUU ) * ( ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU ) )*sU + betaUU * xipUU *  ( (( (pitargetU(+1)^iota1UU) * (piU^(1-iota1UU)) * pibarUU^(1-iota1UU-(1-iota1UU)) )/piU(+1)) ^ (lambdafU(+1)/(1-lambdafU(+1))) ) * ( FpXU(+1)* (( ( (1 - xipUU*(( (pitargetU(+1)^iota1UU) * (piU^(1-iota1UU)) * pibarUU^(1-iota1UU-(1-iota1UU)) )/piU(+1))^(1/(1-lambdafU(+1))) ) / (1-xipUU) ) )^(1-lambdafU(+1))) ) - ( FpXU* (( ( (1 - xipUU*(( (pitargetU^iota1UU) * (piU(-1)^(1-iota1UU)) * pibarUU^(1-iota1UU-(1-iota1UU)) )/piU)^(1/(1-lambdafU)) ) / (1-xipUU) ) )^(1-lambdafU)) );
lambdafU*lambdazU*yU*sU + betaUU * xipUU *  ( (( (piUU^iota1UU) * (piU^(1-iota1UU)) )/piU(+1)) ^ (lambdafU(+1)/(1-lambdafU(+1))) ) * ( FpXU(+1)* (( ( (1 - xipUU*(( (piUU^iota1UU) * (piU^(1-iota1UU))  )/piU(+1))^(1/(1-lambdafU(+1))) ) / (1-xipUU) ) )^(1-lambdafU(+1))) ) - ( FpXU* (( ( (1 - xipUU*(( (piU^iota1UU) * (piU(-1)^(1-iota1UU))  )/piU)^(1/(1-lambdafU)) ) / (1-xipUU) ) )^(1-lambdafU)) );

//Conditions associated with Calvo sticky wages
//(eq A.21)
wstarU - ( ((1-xiwUU)*( ( (1 - xiwUU * ( ( (( (piUU^iotaw1UU) * (piU(-1)^(1-iotaw1UU)))/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawU)) ) ) / (1-xiwUU) ) ^ lambdawU ) + xiwUU*( (( (( (piUU^iotaw1UU) * (piU(-1)^(1-iotaw1UU))  )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) )*wstarU(-1))^( lambdawU/(1-lambdawU) ) ) )^(1/( lambdawU/(1-lambdawU) )) );
//(eq A.22)
((wstarU^(lambdawU/(lambdawU-1)))*hU*(1-taulUU)*lambdazU/lambdawU) + betaUU * xiwUU * (muzstarUU^((1-iotamuUU)/(1-lambdawU(+1)))) * ( (( (piUU^iotaw1UU) * (piU^(1-iotaw1UU))  )^(1/(1-lambdawU(+1)))) / piU(+1) ) * ( (1/( piU(+1)*muzstarU(+1)*wU(+1)/wU )) ^ (lambdawU(+1)/(1-lambdawU(+1))) ) * (muzstarU(+1)^(iotamuUU/(1-lambdawU(+1))-1)) * FwXU(+1) - FwXU;
//(eq A.23)
((wstarU^(lambdawU/(lambdawU-1))*hU)^(1+sigmaLXUU))+ betaUU * xiwUU * (( (( (piUU^iotaw1UU) * (piU^(1-iotaw1UU)))/( piU(+1)*muzstarU(+1)*wU(+1)/wU )) * (muzstarUU^(1-iotamuUU)) * (muzstarU(+1)^iotamuUU) )  ^ (lambdawU(+1)*(1+sigmaLXUU)/(1-lambdawU(+1)))) * ( ( ( (1 - xiwUU * ( ( (( (piUU^iotaw1UU) * (piU^(1-iotaw1UU)))/( piU(+1)*muzstarU(+1)*wU(+1)/wU )) * (muzstarUU^(1-iotamuUU)) * (muzstarU(+1)^iotamuUU) ) ^ (1/(1-lambdawU(+1))) ) ) / (1-xiwUU) ) ^ (1-lambdawU(+1)*(1+sigmaLXUU)) ) * wU(+1) * FwXU(+1)/psiLXUU ) - ( ( ( (1 - xiwUU * ( ( (( (piUU^iotaw1UU) * (piU(-1)^(1-iotaw1UU)))/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawU)) ) ) / (1-xiwUU) )   ^ (1-lambdawU*(1+sigmaLXUU)) ) * wU   * FwXU/psiLXUU );


//marginal cost
((1-alphaUU)^(alphaUU-1)*alphaUU^(-alphaUU))*((rkU*(1+psikUU*RXU))^alphaUU)*((wU*(1+psilUU*RXU))^(1-alphaUU))/epsilU-sU;
//another MC
rkU*(1+psikUU*RXU)/( alphaUU*epsilU*( (upsilUU*muzstarU*hU*(wstarU^(lambdawU/(lambdawU-1)))/(uU*kbarU(-1)))^(1-alphaUU) ) )-sU;
//capital evolution eq
kbarU-(1-deltaUU)*(kbarU(-1)/(muzstarU*upsilU))-(1-sigmaIXUU/2*(zetaiU*iU*muzstarU*upsilU/iU(-1)-muzstarUU*upsilUU)^2)*iU;
//FOC of invest
lambdazU*qU*(1-sigmaIXUU/2*(zetaiU*iU*muzstarU*upsilU/iU(-1)-muzstarUU*upsilUU)^2-sigmaIXUU*(zetaiU*iU*muzstarU*upsilU/iU(-1)-muzstarUU*upsilUU)*zetaiU*iU*muzstarU*upsilU/iU(-1))-lambdazU+betaUU*lambdazU(+1)*qU(+1)*sigmaIXUU/(muzstarU(+1)*upsilU(+1))*(zetaiU(+1)*iU(+1)*muzstarU(+1)*upsilU(+1)/iU-muzstarUU*upsilUU)*(zetaiU(+1)*iU(+1)*muzstarU(+1)*upsilU(+1)/iU)^2;
//FOC of capital utilization
rkU - rkUU*exp(sigmaaUU*(uU-1));
//definition of after tax rate of return on capital
( (1-taukUU)*(uU*rkU-( rkUU*(exp(sigmaaUU*(uU-1))-1)/sigmaaUU ))+(1-deltaUU)*qU)*piU/(upsilU*qU(-1)) + taukUU*deltaUU - 1-RkXU;
//household cousumption condition
(1+taucUU)*lambdazU-muzstarU*zetacU/(cU*muzstarU-bUU*cU(-1))+bUU*betaUU*zetacU(+1)/(cU(+1)*muzstarU(+1)-bUU*cU);
//household D_m condition
-lambdazU+betaUU*lambdazU(+1)*(1+ReXU)/(muzstarU(+1)*piU(+1) );
//household M_t condition
vUU*(mU^thetaUU*(1-mU)^(1-thetaUU))^(1-sigmaqUU)*(thetaUU/mU-(1-thetaUU)/(1-mU))*((piU*muzstarU)/mbU(-1))^sigmaqUU-lambdazU*RaXU;
//household M_b condition
betaUU*(1-thetaUU)*vUU*(mU(+1)^thetaUU*(1-mU(+1))^(1-thetaUU))^(1-sigmaqUU)*((piU(+1)*muzstarU(+1)/mbU)^(sigmaqUU-1))/(1-mU(+1))/mbU+(betaUU*lambdazU(+1)/(piU(+1)*muzstarU(+1)))*(1+RaXU(+1))-lambdazU;
//price eq
//(piU-piUU)/piUU-(1-iota1UU)*(piU(-1)-piUU)/piUU=betaUU*((piU(+1)-piUU)/piUU-(1-iota1UU)*(piU-piUU)/piUU)+(1-betaUU*xipUU)*(1-xipUU)*((lambdafU-lambdafUU)/lambdafUU+(sU-sUU)/sUU)/xipUU;
//wage eq
//(sigmaLXUU*lambdawU-(1-lambdawU))/(1-xiwUU*betaUU)/(1-xiwUU)*xiwUU*(wU(-1)-wUU)/wUU-((1+xiwUU*xiwUU*betaUU)*(sigmaLXUU*lambdawU-(1-lambdawU))/(1-xiwUU*betaUU)/(1-xiwUU)+sigmaLXUU*lambdawU)*(wU-wUU)/wUU+(sigmaLXUU*lambdawU-(1-lambdawU))/(1-xiwUU*betaUU)/(1-xiwUU)*xiwUU*betaUU*(wU(+1)-wUU)/wUU+(sigmaLXUU*lambdawU-(1-lambdawU))/(1-xiwUU*betaUU)/(1-xiwUU)*xiwUU*iotawUU*(piU(-1)-piUU)/piUU-(sigmaLXUU*lambdawU-(1-lambdawU))/(1-xiwUU*betaUU)/(1-xiwUU)*xiwUU*(1+betaUU*iotawUU)*(piU-piUU)/piUU+(sigmaLXUU*lambdawU-(1-lambdawU))/(1-xiwUU*betaUU)/(1-xiwUU)*xiwUU*betaUU*(piU(+1)-piUU)/piUU-sigmaLXUU*(1-lambdawU)*(hU-hUU)/hUU+(1-lambdawU)*(lambdazU-lambdazUU)/lambdazUU+(sigmaLXUU*lambdawU-(1-lambdawU))/(1-xiwUU*betaUU)/(1-xiwUU)*xiwUU*(iotamuUU-1)*(muzstarU-muzstarUU)/muzstarUU-(sigmaLXUU*lambdawU-(1-lambdawU))/(1-xiwUU*betaUU)/(1-xiwUU)*xiwUU*(iotamuUU-1)*betaUU*(muzstarU(+1)-muzstarUU)/muzstarUU;
//resource constraint
yU-gU-cU-iU-(rkUU*(exp(sigmaaUU*(uU-1))-1)/sigmaaUU)*kbarU(-1)/(muzstarU*upsilU)-bigthetaUU*(1-gammaU)*(nU-weUU)/gammaU-muUU*normcdf((log(omegabarU)-sigmaU(-1)^2/2)/sigmaU(-1))*(1+RkXU)*qU(-1)*kbarU(-1)/(muzstarU*piU);
//production eq
yU=(pstarU^(lambdafU/(lambdafU-1)))*epsilU*vlU*(uU*kbarU(-1)/(muzstarU*upsilU))^alphaUU*(hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ))^(1-alphaUU)*sU;
//m2 eq
m2U-psilUU*wU*hU*(wstarU^(lambdawU/(lambdawU-1)))-psikUU*rkU*uU*kbarU(-1)/(muzstarU*upsilU)-(qU(-1)*kbarU(-1)-nU(-1))/(piU*muzstarU)-mbU(-1)/(piU*muzstarU);
//btot eq
btotU-psilUU*wU*hU*(wstarU^(lambdawU/(lambdawU-1)))-psikUU*rkU*uU*kbarU(-1)/(muzstarU*upsilU)-(qU(-1)*kbarU(-1)-nU(-1))/(piU*muzstarU);
//debt contract eq
(1-omegabarU(+1)*(1-normcdf(((log(omegabarU(+1))+sigmaU^2/2)/sigmaU)))-(normcdf(((log(omegabarU(+1))+sigmaU^2/2)/sigmaU)-sigmaU)))*(1+RkXU(+1))/(1+ReXU)+((1-( normcdf((log(omegabarU(+1))+sigmaU^2/2)/sigmaU) ))/(1-( normcdf((log(omegabarU(+1))+sigmaU^2/2)/sigmaU) )-muUU*omegabarU(+1)*( normpdf((log(omegabarU(+1))+sigmaU^2/2)/sigmaU)/omegabarU(+1)/sigmaU )))*(( (1+RkXU(+1))/(1+ReXU) )*( (1-muUU)*normcdf(( (log(omegabarU(+1))+sigmaU^2/2)/sigmaU )-sigmaU)+omegabarU(+1)*(1-normcdf(( (log(omegabarU(+1))+sigmaU^2/2)/sigmaU ))) )-1);
//Zero profit condition for banks on entrepreneurial loans
omegabarU*(1-normcdf(( (log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1))))+(1-muUU)*normcdf(((log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1) )-sigmaU(-1))-(1-nU(-1)/(qU(-1)*kbarU(-1)))*(1+ReXU(-1))/(1+RkXU);
//Law of motion of net worth 
-nU+(gammaU/(piU*muzstarU))*(RkXU-ReXU(-1)-muUU*(1+RkXU)*normcdf((log(omegabarU)-sigmaU(-1)^2/2)/sigmaU(-1)))*kbarU(-1)*qU(-1)+weUU+gammaU*(1+ReXU(-1))*nU(-1)/(piU*muzstarU);
//bank eq
-evU+((1-tauUU)*(mbU(-1)/(piU*muzstarU))*(1-mU)-tauUU*(psilUU*wU*hU*(wstarU^(lambdawU/(lambdawU-1)))+psilUU*rkU*kbarU(-1)*uU/(muzstarU*upsilU)))/((1-vlU)*((uU*kbarU(-1)/(muzstarU*upsilU))^alphaUU)*(hU*(wstarU^(lambdawU/(lambdawU-1)))^(1-alphaUU)));
//bank labor eq
RXU*((1-alphaUU)*ksiUU*xbU*evU^(1-ksiUU)*((kbarU(-1)*uU/(muzstarU*upsilU*hU*(wstarU^(lambdawU/(lambdawU-1)))))^alphaUU))/(1+tauUU*((1-ksiUU)*xbU*(evU^(-ksiUU))))-(1+psilUU*RXU)*wU;
//bank production eq
xbU*(evU^(-ksiUU))*((1-tauUU)*(mbU(-1)/(piU*muzstarU))*(1-mU)-tauUU*(psilUU*wU*hU*(wstarU^(lambdawU/(lambdawU-1)))+psikUU*rkU*kbarU(-1)*uU/(muzstarU*upsilU)))-((mbU(-1)/(piU*muzstarU))*(1-mU)+psilUU*wU*hU*(wstarU^(lambdawU/(lambdawU-1)))+psikUU*rkU*kbarU(-1)*uU/(muzstarU*upsilU));
//bank RaXUU eq
(((1-tauUU)*(1-ksiUU)*xbU*evU^(-ksiUU)-1)/(tauUU*((1-ksiUU)*xbU*(evU^(-ksiUU)))+1))*RXU-RaXU;
//average r
//arU=muUU*normcdf((log(omegabarU)-sigmaU(-1)^2/2)/sigmaU(-1))*(1+RkXU)*kbarU(-1)*qU(-1)/( kbarU(-1)*qU(-1)-nU(-1));
//marginal r
//mrUU=omegabarU*(1+RkXU)*kbarU(-1)*qU(-1)/( kbarU(-1)*qU(-1)-nU(-1))-1-ReXU;

mbU=mbU(-1)*(1+xU)/(piU*muzstarU);
//Policy of G
//ln((1+xU)/(1+xUU))=policytilUU*ln((1+xU(-1))/(1+xUU))-(1-policytilUU)*(policypiUU*ln(piU(-1)/piUU)-policyyUU*ln(yU(-1)/yUU))+e_policyU;
//ln(xU/xUU)=policytilUU*ln(xU(-1)/xUU)-(1-policytilUU)*(policypiUU*ln(piU(-1)/piUU)-policyyUU*ln(yU(-1)/yUU))+e_policyU;
//log(xU)-log(xUU) - policytilUU*(log(xU(-1)) -log(xUU)) +(1/xUU)*(1-policytilUU)*piUU*( log(piU) -log(piUU) ) + (1/xUU)*(1-policytilUU)*policypiUU*piUU*(log(piU(+1)) - log(piUU)) + (1/(4*xUU))*(1-policytilUU)*policyyUU*( cUU/( (cUU+iUU)/(1-etagUU) )*log(cU)+iUU/( (cUU+iUU)/(1-etagUU) )*log(iU)-iUU/( (cUU+iUU)/(1-etagUU) )*log(upsilU)+gUU/( (cUU+iUU)/(1-etagUU) )*log(gU)  - (cUU/( (cUU+iUU)/(1-etagUU) )*log(cUU)+iUU/( (cUU+iUU)/(1-etagUU) )*log(iUU)+gUU/( (cUU+iUU)/(1-etagUU) )*log(gUU)) )   - (1/(400*xUU))*(e_policyU);
log(RXU/RXUU)=policytilUU*ln(RXU(-1)/RXUU)+(1-policytilUU)*(policypiUU*ln(piU(-1)/piUU)+policyyUU*ln(yU(-1)/yUU))+e_policyU;
//RXU=policytilUU*RXU(-1)+(1-policytilUU)*(RXUU+policypiUU*(piU(-1)-piUU)+policyyUU*ln(yU(-1)/yUU))+e_policyU;
//log(ReXU/ReXUU)=policytilUU*ln(ReXU(-1)/ReXUU)+(1-policytilUU)*(policypiUU*ln(piU(-1)/piUU)+policyyUU*ln(yU(-1)/yUU))+e_policyU;
//log(ReXU)-log(ReXUU) - policytilUU*(log(ReXU(-1)) -log(ReXUU)) - (1/ReXUU)*(1-policytilUU)*policypiUU*piUU*(log(piU(+1)) - log(piUU)) - (1/(4*ReXUU))*(1-policytilUU)*policyyUU*( cUU/( (cUU+iUU)/(1-etagUU) )*log(cU)+iUU/( (cUU+iUU)/(1-etagUU) )*log(iU)-iUU/( (cUU+iUU)/(1-etagUU) )*log(upsilU)+gUU/( (cUU+iUU)/(1-etagUU) )*log(gU)  - (cUU/( (cUU+iUU)/(1-etagUU) )*log(cUU)+iUU/( (cUU+iUU)/(1-etagUU) )*log(iUU)+gUU/( (cUU+iUU)/(1-etagUU) )*log(gUU)) )   - (1/(400*ReXUU))*(e_policyU);
//xU = xUU* ( 1 + e_xU) + rho1_xU * (xU(-1) - xUU );

//shock eq take the form:x=x_*(1+e_x)+rho_x*(x(-1)-x_)
gU = gUU* ( 1 + e_gU) + rho1_gU * ( gU(-1) - gUU );
gammaU = gammaUU* ( 1 + e_gammaU) + rho1_gammaU * ( gammaU(-1) - gammaUU );
sigmaU = sigmaUU* ( 1 + e_sigmaU) + rho1_sigmaU * ( sigmaU(-1) - sigmaUU );
lambdafU = lambdafUU* ( 1 + e_lambdafU) + rho1_lambdafU * ( lambdafU(-1) - lambdafUU );
epsilU = epsilUU* ( 1 + e_epsilU) + rho1_epsilU * ( epsilU(-1) - epsilUU );
muzstarU=muzU*(upsilU)^(alphaUU/(1-alphaUU));
muzU = muzUU* ( 1 + e_muzU) + rho1_muzU * ( muzU(-1) - muzUU );
zetaiU = zetaiUU* ( 1 + e_zetaiU) + rho1_zetaiU * ( zetaiU(-1) - zetaiUU );
zetacU = zetacUU* ( 1 + e_zetacU) + rho1_zetacU * ( zetacU(-1) - zetacUU );
sigmaqU = sigmaqUU* ( 1 + e_sigmaqU) + rho1_sigmaqU * ( sigmaqU(-1) - sigmaqUU );
upsilU = upsilUU* ( 1 + e_upsilU) + rho1_upsilU * ( upsilU(-1) - upsilUU );
lambdawU = lambdawUU* ( 1 + e_lambdawU) + rho1_lambdawU * ( lambdawU(-1) - lambdawUU );
xbU = xbUU* ( 1 + e_xbU) + rho1_xbU * (xbU(-1) - xbUU );


//obs eq
gp_obs=piU;
gy_obs=yU/yU(-1)*muzstarU;
gc_obs=cU/cU(-1)*muzstarU*1.002558;
gi_obs=iU/iU(-1)*muzstarU*1.022234;
gm2_obs=m2U/m2U(-1)*muzstarU*1.008929;
gm_obs=mbU/mbU(-1)*muzstarU*1.005767;
gw_obs=wU/wU(-1)*muzstarU*1.003188;
R_obs=100*(RXU-RXUU);
gg_obs=gU/gU(-1)*muzstarU*1.015241;
gn_obs=nU/nU(-1)*muzstarU*1.04943;
gh_obs=hU/hU(-1)*muzstarU*0.97241;
end;


initval;

pstarU=pstarUU;
FpXU=FpXUU;
wstarU=wstarUU;
FwXU=FwXUU;
//arU=arUU;
//mrU=mrUU;

//SS var
piU = piUU;
sU = sUU;
rkU = rkUU;
iU = iUU;
uU = uUU;
qU = qUU;
mbU=mbUU;
RXU=RXUU;
RkXU = RkXUU;
lambdazU = lambdazUU;
mU = mUU;
cU = cUU;
wU = wUU;
hU = hUU;
kbarU = kbarUU;
yU = yUU;
omegabarU=omegabarUU;
nU=nUU;
vlU=vlUU;
evU=evUU;
RaXU=RaXUU;
ReXU=ReXUU;
m2U=m2UU;
btotU=btotUU;

//obs var
gp_obs=piUU;
gy_obs=muzstarUU;
gc_obs=muzstarUU*1.002558;
gi_obs=muzstarUU*1.022234;
gm2_obs=muzstarUU*1.008929;
gm_obs=muzstarUU*1.005767;
gw_obs=muzstarUU*1.003188;
R_obs=0;
gg_obs=muzstarUU*1.015241;
gn_obs=muzstarUU*1.04943;
gh_obs=muzstarUU*0.97241;

//shock var
lambdafU=lambdafUU;
gU=gUU;
muzstarU=muzstarUU;
muzU=muzstarUU;
zetaiU=zetaiUU;
xU=xUU;
epsilU=epsilUU;
zetacU=zetacUU;
upsilU=upsilUU;
sigmaqU=sigmaqUU;
lambdawU=lambdawUU;
xbU=xbUU;
gammaU=gammaUU;
sigmaU=sigmaUU;

end;

resid(1);
model_diagnostics;

//return
//var og shock
shocks;
var e_lambdafU=0.01;
var e_epsilU=0.01;
var e_gU=0.01;
var e_muzU=0.01;
var e_zetaiU=0.01;
var e_policyU=0.01;
var e_zetacU=0.01;
var e_sigmaqU=0.01;
var e_upsilU=0.01;
var e_lambdawU=0.01;
var e_xbU=0.01;
var e_gammaU=0.01;
var e_sigmaU=0.01;


end;

estimated_params;
xipUU,beta_pdf,0.5,0.1;
xiwUU,beta_pdf,0.5,0.1;
iotamuUU,beta_pdf,0.5,0.15;
iota1UU,beta_pdf,0.5,0.15;
iotaw1UU,beta_pdf,0.5,0.15;
sigmaIXUU,gamma_pdf,5,1.5;
sigmaaUU,gamma_pdf,6,5;
rho1_lambdafU,beta_pdf,0.5,0.2;
rho1_epsilU,beta_pdf,0.5,0.2;
rho1_gU,beta_pdf,0.5,0.2;
rho1_muzU,beta_pdf,0.5,0.2;
rho1_zetaiU,beta_pdf,0.5,0.2;
rho1_zetacU,beta_pdf,0.5,0.2;
rho1_sigmaqU,beta_pdf,0.5,0.2;
rho1_upsilU,beta_pdf,0.5,0.2;
rho1_lambdawU,beta_pdf,0.5,0.2;
rho1_gammaU,beta_pdf,0.5,0.2;
rho1_sigmaU,beta_pdf,0.5,0.2;
rho1_xbU,beta_pdf,0.5,0.2;


stderr e_lambdafU,inv_gamma_pdf,0.1,2;
stderr e_epsilU,inv_gamma_pdf,0.1,2;
stderr e_gU,inv_gamma_pdf,0.1,2;
stderr e_muzU,inv_gamma_pdf,0.1,2;
stderr e_zetaiU,inv_gamma_pdf,0.1,2;
stderr e_policyU,inv_gamma_pdf,0.1,2;
stderr e_zetacU,inv_gamma_pdf,0.1,2;
stderr e_sigmaqU,inv_gamma_pdf,0.1,2;
stderr e_upsilU,inv_gamma_pdf,0.1,2;
stderr e_lambdawU,inv_gamma_pdf,0.1,2;
stderr e_sigmaU,inv_gamma_pdf,0.1,2;
stderr e_gammaU,inv_gamma_pdf,0.1,2;
stderr e_xbU,inv_gamma_pdf,0.1,2;


policytilUU,beta_pdf,0.95,0.01;
policypiUU,normal_pdf,1.5,0.2;
policyyUU,normal_pdf,1.2,0.2;

end;

steady;
check;

varobs  gp_obs, gc_obs, gi_obs, gy_obs, R_obs, gw_obs, gg_obs, gm2_obs, gn_obs, gh_obs, gm_obs;//
estimation(datafile=data3, mode_compute=9, mh_replic=2000,mode_check,smoother);
stoch_simul(order=1)yU,cU,iU,piU,nU,RXU,RaXU,mbU;

